package com.zhongzheng.modules.grade.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.domain.MajorProject;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.grade.bo.ClassGradeInterfaceAddBo;
import com.zhongzheng.modules.grade.bo.ClassGradeInterfaceQueryBo;
import com.zhongzheng.modules.grade.bo.ClassGradeInterfaceEditBo;
import com.zhongzheng.modules.grade.domain.ClassGradeInterface;
import com.zhongzheng.modules.grade.mapper.ClassGradeInterfaceMapper;
import com.zhongzheng.modules.grade.vo.ClassGradeInterfaceVo;
import com.zhongzheng.modules.grade.service.IClassGradeInterfaceService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 官方接口Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-10
 */
@Service
public class ClassGradeInterfaceServiceImpl extends ServiceImpl<ClassGradeInterfaceMapper, ClassGradeInterface> implements IClassGradeInterfaceService {

    @Override
    public ClassGradeInterfaceVo queryById(Long id){
        ClassGradeInterface db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ClassGradeInterfaceVo.class);
    }

    @Override
    public List<ClassGradeInterfaceVo> queryList(ClassGradeInterfaceQueryBo bo) {
        LambdaQueryWrapper<ClassGradeInterface> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getType() != null, ClassGradeInterface::getType, bo.getType());
        lqw.like(StrUtil.isNotBlank(bo.getName()), ClassGradeInterface::getName, bo.getName());
        lqw.in(bo.getStatus() != null, ClassGradeInterface::getStatus, bo.getStatus());
        lqw.orderByDesc(ClassGradeInterface::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ClassGradeInterfaceVo> entity2Vo(Collection<ClassGradeInterface> collection) {
        List<ClassGradeInterfaceVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ClassGradeInterfaceVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ClassGradeInterface> page = (Page<ClassGradeInterface>)collection;
            Page<ClassGradeInterfaceVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ClassGradeInterfaceAddBo bo) {
        ClassGradeInterface add = BeanUtil.toBean(bo, ClassGradeInterface.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ClassGradeInterfaceEditBo bo) {
        ClassGradeInterface update = BeanUtil.toBean(bo, ClassGradeInterface.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ClassGradeInterface entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
